#!/usr/bin/perl -I/usr/sausalito/perl -I/usr/sausalito/handlers/base/winshare

use Sauce::Config;
use Sauce::Service;
use CCE;
use smb;
use I18n;

my $cce = new CCE;
$cce->connectuds();

my $i18n = new I18n;

my @oids = $cce->find('System');
if (not @oids) {
        $cce->bye('FAIL');
        exit 1;
}

my ($ok, $obj) = $cce->get($oids[0], 'WinShare');
unless ($ok and $obj) {
        $cce->bye('FAIL');
        exit 1;
}

# find out if it's enabled
my $old = Sauce::Service::service_get_init('smb') ? 'on' : 'off';
my $new = $obj->{enabled} ? 'on' : 'off';
Sauce::Service::service_set_init('smb', $new) unless ($new eq $old);

# fix up numbers of users, locale stuff and guest user
my %settings;
$settings{'max connections'} = $obj->{maxConnections};
$settings{'client code page'} = $i18n->getProperty("sambaCodePage","base-winshare");

if($i18n->getProperty("sambaCodingSystem","base-winshare") ne "none"){
	$settings{'codingsystem'} = $i18n->getProperty("sambaCodingSystem","base-winshare");
}

($ok, $obj) = $cce->get($oids[0], 'FileShare');
$settings{'guest account'} = $obj->{guestUser};

Sauce::Util::editfile(smb::smb_getconf, *smb::edit_global,
		      %settings);

# sync up guest share
Sauce::Util::editfile(smb::smb_getconf, *smb::edit_guest,
		      $old->{guestGroup}, $obj->{guestGroup},
		      $obj->{guestEnabled});


$cce->bye('SUCCESS');
exit 0;
1;
